% --------------------------------------------------------------
% N Queens Problem - Turbo Solver
% Viktor Engelmann
% www.AlgorithMan.de
% --------------------------------------------------------------
% this code is provided under the terms of the GNU General
% Public License v3. See gpl3.txt for details
% --------------------------------------------------------------


generiere_liste(0,[]):-!.
generiere_liste(T,[T|L]):-
   T2 is T - 1,
   generiere_liste(T2,L).


delete(X,[X|R],R).
delete(X,[Y|R],[Y|L]):-
   delete(X,R,L).


bedroht_nicht(_,[],_).
bedroht_nicht(Dame,[Weitere|Rest],Abstand) :-
   Dame + Abstand =\= Weitere,
   Dame - Abstand =\= Weitere,
   Abstand1 is Abstand + 1,
   bedroht_nicht(Dame,Rest,Abstand1).


turbodamen_filter(0,_,Result,Result).
turbodamen_filter(N,Vorrat,TempResult,Result) :-
   N > 0,
   N1 is N - 1,
   delete(D,Vorrat,RestVorrat),
   bedroht_nicht(D,TempResult,1),
   turbodamen_filter(N1,RestVorrat,[D|TempResult],Result).


turbodamen(N,Feld):-
   generiere_liste(N,Vorrat),
   turbodamen_filter(N,Vorrat,[],Feld).
